require '_h2ph_pre.ph';

unless(defined(&_MACHINE_ASM_H_)) {
    eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
    eval 'sub R0 () {0x001;}' unless defined(&R0);
    eval 'sub R1 () {0x002;}' unless defined(&R1);
    eval 'sub R2 () {0x004;}' unless defined(&R2);
    eval 'sub R3 () {0x008;}' unless defined(&R3);
    eval 'sub R4 () {0x010;}' unless defined(&R4);
    eval 'sub R5 () {0x020;}' unless defined(&R5);
    eval 'sub R6 () {0x040;}' unless defined(&R6);
    eval 'sub R7 () {0x080;}' unless defined(&R7);
    eval 'sub R8 () {0x100;}' unless defined(&R8);
    eval 'sub R9 () {0x200;}' unless defined(&R9);
    eval 'sub R10 () {0x400;}' unless defined(&R10);
    eval 'sub R11 () {0x800;}' unless defined(&R11);
    if(defined(&__ELF__)) {
	eval 'sub _C_LABEL {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&_C_LABEL);
    } else {
	if(defined(&__STDC__)) {
	    eval 'sub _C_LABEL {
	        local($x) = @_;
    		eval q( &_  $x);
	    }' unless defined(&_C_LABEL);
	} else {
	    eval 'sub _C_LABEL {
	        local($x) = @_;
    		eval q( &_x);
	    }' unless defined(&_C_LABEL);
	}
    }
    eval 'sub _ASM_LABEL {
        local($x) = @_;
	    eval q($x);
    }' unless defined(&_ASM_LABEL);
    if(defined(&__STDC__)) {
	eval 'sub __CONCAT {
	    local($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
    } else {
	eval 'sub __CONCAT {
	    local($x,$y) = @_;
    	    eval q( &xy);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    local($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
    }
    unless(defined(&_ALIGN_TEXT)) {
	if(defined(&__ELF__)) {
	    eval 'sub _ALIGN_TEXT () {. &align 4;}' unless defined(&_ALIGN_TEXT);
	} else {
	    eval 'sub _ALIGN_TEXT () {. &align 2;}' unless defined(&_ALIGN_TEXT);
	}
    }
    eval 'sub _ENTRY {
        local($x, $regs) = @_;
	    eval q(. &text;  &_ALIGN_TEXT; . &globl $x; . &type $x,@ &function; $x: . &word $regs);
    }' unless defined(&_ENTRY);
    if(defined(&GPROF)) {
	if(defined(&__ELF__)) {
	    eval 'sub _PROF_PROLOGUE () {. &data; 1:; .\'long 0\'; . &text;  &moval 1 &b, &r0;  &jsb  &_ASM_LABEL( &__mcount);}' unless defined(&_PROF_PROLOGUE);
	} else {
	    eval 'sub _PROF_PROLOGUE () {. &data; 1:; .\'long 0\'; . &text;  &moval 1 &b, &r0;  &jsb  &_ASM_LABEL( &mcount);}' unless defined(&_PROF_PROLOGUE);
	}
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub ENTRY {
        local($x, $regs) = @_;
	    eval q( &_ENTRY( &_C_LABEL($x), $regs);  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub NENTRY {
        local($x, $regs) = @_;
	    eval q( &_ENTRY( &_C_LABEL($x), $regs));
    }' unless defined(&NENTRY);
    eval 'sub ASENTRY {
        local($x, $regs) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($x), $regs);  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub ALTENTRY {
        local($x) = @_;
	    eval q(. &globl  &_C_LABEL($x);  &_C_LABEL($x):);
    }' unless defined(&ALTENTRY);
    eval 'sub RCSID {
        local($x) = @_;
	    eval q(. &text; . &asciz $x);
    }' unless defined(&RCSID);
    if(defined(&__ELF__)) {
	eval 'sub WEAK_ALIAS {
	    local($alias,$sym) = @_;
    	    eval q(. &weak $alias; $alias = $sym);
	}' unless defined(&WEAK_ALIAS);
    }
    if(defined(&__STDC__)) {
	eval 'sub WARN_REFERENCES {
	    local($sym,$msg) = @_;
    	    eval q(. &stabs $msg  ,30,0,0,0; . &stabs  &__STRING( &_C_LABEL($sym))  ,1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    } else {
	eval 'sub WARN_REFERENCES {
	    local($sym,$msg) = @_;
    	    eval q(. &stabs $msg,30,0,0,0; . &stabs  &__STRING( &_C_LABEL($sym)),1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    }
}
1;
